
;*********************************************************************
;  Debugausgabe
;
;  Scratch-Reg: -
;*********************************************************************

#ifdef	USE_DEBUG

debug_flash_system:

		setbank	BANK_0

		load_p	Z,(2*text_flash)
		rcall	uart_send_text
		rcall	uart_send_newline

		load_p	Y,32
		load_p	Z,FLASH_START

		rcall	uart_send_hex_tab

		ret

debug_flash_screen:

		setbank	BANK_0

		load_p	Z,(2*text_flash)
		rcall	uart_send_text
		rcall	uart_send_newline

		load_p	Y,32
		load_p	Z,FLASH_START+128

		rcall	uart_send_hex_tab

		ret

debug_flash_font:

		setbank	BANK_0

		load_p	Z,(2*text_flash)
		rcall	uart_send_text
		rcall	uart_send_newline

		load_p	Y,32
		load_p	Z,FLASH_START+128+128

		rcall	uart_send_hex_tab

		ret

debug_flash_daten:

		setbank	BANK_0

		load_p	Z,(2*text_flash)
		rcall	uart_send_text
		rcall	uart_send_newline

		load_p	Y,256
		load_p	Z,FLASH_START+128+128+128

		rcall	uart_send_hex_tab

		ret

debug_font_daten:

		load_p	Z,(2*text_font)
		rcall	uart_send_text
		mov		TEMP_0,FONT_NUM
		rcall	uart_send_byte_hex
		rcall	uart_send_newline

		load_p	Z,(2*text_font_bank)
		rcall	uart_send_text
		lds		TEMP_0,FONT_BANK
		rcall	uart_send_byte_hex
		rcall	uart_send_newline

		load_p	Z,(2*text_font_adr)
		rcall	uart_send_text
		lds		TEMP_0,FONT_START+1
		rcall	uart_send_byte_hex
		lds		TEMP_0,FONT_START
		rcall	uart_send_byte_hex
		rcall	uart_send_newline

		load_p	Z,(2*text_font_breite)
		rcall	uart_send_text
		lds		TEMP_0,FONT_WIDTH
		rcall	uart_send_byte_hex
		rcall	uart_send_newline

		load_p	Z,(2*text_font_hoehe)
		rcall	uart_send_text
		lds		TEMP_0,FONT_HEIGH
		rcall	uart_send_byte_hex
		rcall	uart_send_newline

		ret

;******************************** Sub-Intern *******************************
; Sub: Speicher als 32-Bit (4-Byte) Tabelle ausgeben
; Parameter:    Z - Adresse
; Parameter:    Y - Lnge
; Return:       -
; Scratch-Reg:  -
;***************************************************************************

uart_send_hex_tab:
        
		ldi		TEMP_0,4

uart_send_hex_tab_loop:
		lsr     YH                   				; /16
        ror     YL
		dec		TEMP_0
		brne	uart_send_hex_tab_loop

uart_send_hex_tab_line_loop:
        mov		TEMP_0,ZH            				; Adresse senden
        rcall	uart_send_byte_hex
        mov     TEMP_0,ZL
        rcall   uart_send_byte_hex

        ldi     TEMP_1,16							; Bytecounter

uart_send_hex_tab_byte_loop:
        ldi     TEMP_0,' '           				; Leerzeichen
        rcall   uart_send_byte

        ld      TEMP_0,Z+
        rcall   uart_send_byte_hex

        dec		TEMP_1
        brne    uart_send_hex_tab_byte_loop

        rcall   uart_send_newline
        sbiw    Y,1
        brne    uart_send_hex_tab_line_loop

        ret

;*********************************************************************
;  Display-Test schreibt Zeichensatz ins Display
;  In:  -
;.
;  Scratch-Reg: Z, TEMP_0, TEMP_1, TEMP_2, TEMP_3
;*********************************************************************

display_test:
/*
		ldi		TEMP_0,0						; Font Nummer 0
		rcall	display_set_font_init
*/
		ldi		TEMP_0,' '+1

		ldi		TEMP_1,30						; Zeichen pro Zeile

display_test_line_loop_1:
		push	TEMP_0
		push	TEMP_1
		rcall	display_write_char
		pop		TEMP_1
		pop		TEMP_0

		rcall	uart_send_byte

		inc		TEMP_0
		dec		TEMP_1
		brne	display_test_line_loop_1

		rcall	uart_send_newline

		ret

;*********************************************************************
;  Display-Test schreibt Zeichensatz ins Display
;  In:  -
;.
;  Scratch-Reg: Z, TEMP_0, TEMP_1, TEMP_2, TEMP_3
;*********************************************************************

debug_flash_write:

		push	TEMP_1

		rcall	uart_send_newline

		push	ZL
		push	ZH
		load_p	Z,(2*text_flash_buffer)
		rcall	uart_send_text
		pop		ZH
		pop		ZL

		mov		TEMP_0,ZH
		rcall	uart_send_byte_hex
		mov		TEMP_0,ZL
		rcall	uart_send_byte_hex
		rcall	uart_send_newline

		push	ZL
		push	ZH
		load_p	Z,(2*text_flash_bank)
		rcall	uart_send_text
		pop		ZH
		pop		ZL

		lds		TEMP_0,FLASH_BANK			; Bank holen
		rcall	uart_send_byte_hex
		rcall	uart_send_newline


		push	ZL
		push	ZH
		load_p	Z,(2*text_flash_adresse)
		rcall	uart_send_text
		pop		ZH
		pop		ZL

		mov		TEMP_0,YH					; Flash-Startadresse
		rcall	uart_send_byte_hex
		mov		TEMP_0,YL
		rcall	uart_send_byte_hex
		rcall	uart_send_newline


		push	ZL
		push	ZH
		load_p	Z,(2*text_flash_anzahl)
		rcall	uart_send_text
		pop		ZH
		pop		ZL
		pop		TEMP_0						; Anzahl Pages aus TEMP_1 holen
		push	TEMP_0
		rcall	uart_send_byte_hex
		rcall	uart_send_newline

		pop		TEMP_1

		ret
#endif
