
;************** IRQ - Routinen ********************************************				 

;*********************************************************************
;  Timer 0 Interrupt, 200kHz, 60 Takte bei 12MHz, Display-Refresh
;	17 Zyklen pro Byte in der Zeile
;	23 Zyklen bei Zeilenwechsel
;	31 Zyklen bei Framewechsel
;  Scratch-Reg: -
;*********************************************************************

irq_refresh:									; #4...5 fr IRQ-Aufruf
		in		REGSAVE,SREG					; #1 SREG retten
		dec		X_REG							; #1 Zeilenende?
		breq	irq_refresh_line_end			; #1/#2 ja

		ld		TEMP_IRQ,X+						; #2/-- nein, Daten aus Ram holen
		out		SPDR,TEMP_IRQ					; #1/--mit SPI rausschieben
		rjmp	irq_refresh_end					; #2/--

irq_refresh_line_end:
		sbi		LCD_PORT,LCD_LP					; --/#2 Zeile ins Latch
		ldi		X_REG,X_SIZE+1					; --/#1 61. Zyklus ist Latch/Zeilenwechsel
		cbi		LCD_PORT,LCD_LP					; --/#2

		cbi		LCD_PORT,LCD_FLM				; --/#2 FLM auf L
			
irq_refresh_line_0:
		dec		Y_REG							; --/#1 nchste Zeile
		brne	irq_refresh_end					; --/#2/#1 nein

		sbi		LCD_PORT,LCD_FLM				; --/--/#2 FLM fr erste Zeile setzen

		in		TEMP_IRQ,LCD_PORT				; --/--/#1 M invertieren
		eor		TEMP_IRQ,M_MASK_REG				; --/--/#1
		out		LCD_PORT,TEMP_IRQ

		ldi		Y_REG,Y_SIZE					; --/--/#1 neues Bild
		lds		XH,DISPLAY+1					; --/--/#2 Startadresse wieder laden
		lds		XL,DISPLAY						; --/--/#2

irq_refresh_end:
		out 	SREG,REGSAVE					; #1

		reti									; #4

