
;**************************** Allgemeine Routinen **************************

;*********************************************************************
;  Warte 10ms
;
;  Scratch-Reg: -
;*********************************************************************

wait_20ms:
        push    ZL
        push    ZH

        load_p  Z,10000*(CYCLES_PER_US/4)
		; 10 mS warten, 4 = Anzahl Befehls-Zyclen vom sbiw + brcc

d_loop:
        sbiw    ZL,1
        brne    d_loop

        pop     ZH
        pop     ZL

        ret

;*********************************************************************
;  Warte 10s
;
;  Scratch-Reg: -
;*********************************************************************

wait_10us:
		push	TEMP_0
		ldi		TEMP_0,10*(CYCLES_PER_US/3)

wait_10us_loop:
		dec		TEMP_0
		brne	wait_10us_loop
		
		pop		TEMP_0

		ret

;*********************************************************************
;  Check Nibble testet auf 0...9, A...F  
;  In:  		TEMP_0 ASCII-Datenbyte, T = 0, bei Fehler T = 1
;  Out: 		TEMP_0 Binrwert im unteren Nibble
;  Scratch-Reg: -
;*********************************************************************

check_nibble:
		clt

		subi	TEMP_0,'0'						; ASCII nach binr
		cpi		TEMP_0,10
		brlo	check_nibble_ok					; 0...9

		subi	TEMP_0,7						; Korrektur A...F

check_nibble_ok:
		cpi		TEMP_0,16						; 0...15?
		brlo	check_nibble_end

check_nibble_err:
		load_p	Z,(2*text_flasherr_2)
		rcall	display_newline
		rcall	display_write_text
		set										; T setzen fr Fehler

check_nibble_end:
		ret

;*********************************************************************
;  Show_Text	Line Textzeile ber Display und UART ausgeben mit Zeilenwechsel am Ende  
;  In:			Z zeigt auf Text im Programm-Flash 	
;  Out:			-
;  Scratch-Reg:	-
;*********************************************************************

show_text_line:
		rcall	display_write_text	
		rcall	display_newline	
		rcall	uart_send_text			
		rcall	uart_send_newline	

		ret

;*********************************************************************
;  Dummy fr Funktionsaufrufe
;
;  Scratch-Reg: -
;*********************************************************************

dummy:
		ret

